Xapian: API Documentation: Xapian::PostingSource Class Reference

xapian-core 1.4.29

Public Member Functions | List of all members
Xapian::PostingSource Class Referenceabstract

Base class which provides an "external" source of postings. More...

`#include <postingsource.h>`

Inheritance diagram for Xapian::PostingSource:
[legend]

## Public Member Functions
| PostingSource ()
| Allow subclasses to be instantiated.
virtual Xapian::doccount | get_termfreq_min () const =0
| A lower bound on the number of documents this object can return.
virtual Xapian::doccount | get_termfreq_est () const =0
| An estimate of the number of documents this object can return.
virtual Xapian::doccount | get_termfreq_max () const =0
| An upper bound on the number of documents this object can return.
void | set_maxweight (double max_weight)
| Specify an upper bound on what get_weight() will return from now on.
double | get_maxweight () const
| Return the currently set upper bound on what get_weight() can return.
virtual double | get_weight () const
| Return the weight contribution for the current document.
virtual Xapian::docid | get_docid () const =0
| Return the current docid.
virtual void | next (double min_wt)=0
| Advance the current position to the next matching document.
virtual void | skip_to (Xapian::docid did, double min_wt)
| Advance to the specified docid.
virtual bool | check (Xapian::docid did, double min_wt)
| Check if the specified docid occurs.
virtual bool | at_end () const =0
| Return true if the current position is past the last entry in this list.
virtual PostingSource * | clone () const
| Clone the posting source.
virtual std::string | name () const
| Name of the posting source class.
virtual std::string | serialise () const
| Serialise object parameters into a string.
virtual PostingSource * | unserialise (const std::string &serialised) const
| Create object given string serialisation returned by serialise().
virtual PostingSource * | unserialise_with_registry (const std::string &serialised, const Registry &registry) const
| Create object given string serialisation returned by serialise().
virtual void | init (const Database &db)=0
| Set this PostingSource to the start of the list of postings.
virtual std::string | get_description () const
| Return a string describing this object.
PostingSource * | release ()
| Start reference counting this object.
const PostingSource * | release () const
| Start reference counting this object.

## Detailed Description

Base class which provides an "external" source of postings.

## Member Function Documentation

## ◆ at_end()

virtual bool Xapian::PostingSource::at_end | ( |  | ) | const
| pure virtual

Return true if the current position is past the last entry in this list.

At least one of next(), skip_to() or check() will be called before this method is first called.

Implemented in Xapian::ValuePostingSource, and Xapian::FixedWeightPostingSource.

## ◆ check()

virtual bool Xapian::PostingSource::check | ( | Xapian::docid | did,
|  | double | min_wt
| ) |  |
| virtual

Check if the specified docid occurs.

The caller is required to ensure that the specified document id did actually exists in the database. If it does, it must move to that document id, and return true. If it does not, it may either:

- return true, having moved to a definite position (including "at_end"), which must be the same position as skip_to() would have moved to.

or

- return false, having moved to an "indeterminate" position, such that a subsequent call to next() or skip_to() will move to the next matching position after did.

Generally, this method should act like skip_to() and return true if that can be done at little extra cost.

Otherwise it should simply check if a particular docid is present, returning true if it is, and false if it isn't.

The default implementation calls skip_to() and always returns true.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Parameters

  did | The document id to check.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValuePostingSource, Xapian::DecreasingValueWeightPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ clone()

virtual PostingSource * Xapian::PostingSource::clone | ( |  | ) | const
| virtual

Clone the posting source.

The clone should inherit the configuration of the parent, but need not inherit the state. ie, the clone does not need to be in the same iteration position as the original: the matcher will always call init() on the clone before attempting to move the iterator, or read the information about the current position of the iterator.

This may return NULL to indicate that cloning is not supported. In this case, the PostingSource may only be used with a single-database search.

The default implementation returns NULL.

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, Xapian::ValueMapPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ get_description()

virtual std::string Xapian::PostingSource::get_description | ( |  | ) | const
| virtual

Return a string describing this object.

This default implementation returns a generic answer. This default it provided to avoid forcing those deriving their own PostingSource subclass from having to implement this (they may not care what get_description() gives for their subclass).

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, Xapian::ValueMapPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ get_docid()

virtual Xapian::docid Xapian::PostingSource::get_docid | ( |  | ) | const
| pure virtual

Return the current docid.

This method may assume that it will only be called when there is a "current document". See get_weight() for details.

Note: in the case of a multi-database search, the returned docid should be in the single subdatabase relevant to this posting source. See the init() method for details.

Implemented in Xapian::ValuePostingSource, and Xapian::FixedWeightPostingSource.

## ◆ get_termfreq_est()

virtual Xapian::doccount Xapian::PostingSource::get_termfreq_est | ( |  | ) | const
| pure virtual

An estimate of the number of documents this object can return.

It must always be true that:

get_termfreq_min() <= get_termfreq_est() <= get_termfreq_max()

Xapian will always call init() on a PostingSource before calling this for the first time.

Implemented in Xapian::ValuePostingSource, and Xapian::FixedWeightPostingSource.

## ◆ get_termfreq_max()

virtual Xapian::doccount Xapian::PostingSource::get_termfreq_max | ( |  | ) | const
| pure virtual

An upper bound on the number of documents this object can return.

Xapian will always call init() on a PostingSource before calling this for the first time.

Implemented in Xapian::ValuePostingSource, and Xapian::FixedWeightPostingSource.

## ◆ get_termfreq_min()

virtual Xapian::doccount Xapian::PostingSource::get_termfreq_min | ( |  | ) | const
| pure virtual

A lower bound on the number of documents this object can return.

Xapian will always call init() on a PostingSource before calling this for the first time.

Implemented in Xapian::ValuePostingSource, and Xapian::FixedWeightPostingSource.

## ◆ get_weight()

virtual double Xapian::PostingSource::get_weight | ( |  | ) | const
| virtual

Return the weight contribution for the current document.

This default implementation always returns 0, for convenience when implementing "weight-less" PostingSource subclasses.

This method may assume that it will only be called when there is a "current document". In detail: Xapian will always call init() on a PostingSource before calling this for the first time. It will also only call this if the PostingSource reports that it is pointing to a valid document (ie, it will not call it before calling at least one of next(), skip_to() or check(), and will ensure that the PostingSource is not at the end by calling at_end()).

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, Xapian::ValueMapPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ init()

virtual void Xapian::PostingSource::init | ( | const Database & | db | ) |
| pure virtual

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, init() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters

  db | The database which the PostingSource should iterate through.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

Implemented in Xapian::LatLongDistancePostingSource, Xapian::ValuePostingSource, Xapian::ValueWeightPostingSource, Xapian::ValueMapPostingSource, Xapian::FixedWeightPostingSource, and Xapian::DecreasingValueWeightPostingSource.

## ◆ name()

virtual std::string Xapian::PostingSource::name | ( |  | ) | const
| virtual

Name of the posting source class.

This is used when serialising and unserialising posting sources; for example, for performing remote searches.

If the subclass is in a C++ namespace, the namespace should be included in the name, using "::" as a separator. For example, for a PostingSource subclass called "FooPostingSource" in the "Xapian" namespace the result of this call should be "Xapian::FooPostingSource".

This should only be implemented if serialise() and unserialise() are also implemented. The default implementation returns an empty string.

If this returns an empty string, Xapian will assume that serialise() and unserialise() are not implemented.

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, Xapian::ValueMapPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ next()

virtual void Xapian::PostingSource::next | ( | double | min_wt | ) |
| pure virtual

Advance the current position to the next matching document.

The PostingSource starts before the first entry in the list, so next(), skip_to() or check() must be called before any methods which need the context of the current position.

Xapian will always call init() on a PostingSource before calling this for the first time.

Parameters

  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Implemented in Xapian::LatLongDistancePostingSource, Xapian::ValuePostingSource, Xapian::DecreasingValueWeightPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ release() [1/2]

PostingSource * Xapian::PostingSource::release | ( |  | ) |
| inline

Start reference counting this object.

You can transfer ownership of a dynamically allocated PostingSource object to Xapian by calling release() and then passing the object to a Xapian method. Xapian will arrange to delete the object once it is no longer required.

## ◆ release() [2/2]

const PostingSource * Xapian::PostingSource::release | ( |  | ) | const
| inline

Start reference counting this object.

You can transfer ownership of a dynamically allocated PostingSource object to Xapian by calling release() and then passing the object to a Xapian method. Xapian will arrange to delete the object once it is no longer required.

## ◆ serialise()

virtual std::string Xapian::PostingSource::serialise | ( |  | ) | const
| virtual

Serialise object parameters into a string.

The serialised parameters should represent the configuration of the posting source, but need not (indeed, should not) represent the current iteration state.

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, Xapian::ValueMapPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ set_maxweight()

void Xapian::PostingSource::set_maxweight | ( | double | max_weight | ) |

Specify an upper bound on what get_weight() will return from now on.

This upper bound is used by the matcher to perform various optimisations, so if you can return a good bound, then matches will generally run faster.

This method should be called after calling init(), and may be called during iteration if the upper bound drops. It is probably only useful to call from subclasses (it was actually a "protected" method prior to Xapian 1.3.4, but that makes it tricky to wrap for other languages).

It is valid for the posting source to have returned a higher value from get_weight() earlier in the iteration, but the posting source must not return a higher value from get_weight() than the currently set upper bound, and the upper bound must not be increased (until init() has been called).

If you don't call this method, the upper bound will default to 0, for convenience when implementing "weight-less" PostingSource subclasses.

Parameters

  max_weight | The upper bound to set.

## ◆ skip_to()

virtual void Xapian::PostingSource::skip_to | ( | Xapian::docid | did,
|  | double | min_wt
| ) |  |
| virtual

Advance to the specified docid.

If the specified docid isn't in the list, position ourselves on the first document after it (or at_end() if no greater docids are present).

If the current position is already the specified docid, this method will leave the position unmodified.

If the specified docid is earlier than the current position, the behaviour is unspecified. A sensible behaviour would be to leave the current position unmodified, but it is also reasonable to move to the specified docid.

The default implementation calls next() repeatedly, which works but skip_to() can often be implemented much more efficiently.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Parameters

  did | The document id to advance to.
  min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented in Xapian::LatLongDistancePostingSource, Xapian::ValuePostingSource, Xapian::DecreasingValueWeightPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ unserialise()

virtual PostingSource * Xapian::PostingSource::unserialise | ( | const std::string & | serialised | ) | const
| virtual

Create object given string serialisation returned by serialise().

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

If you don't want to support the remote backend, you can use the default implementation which simply throws Xapian::UnimplementedError.

Parameters

  serialised | A serialised instance of this PostingSource subclass.

Reimplemented in Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, Xapian::ValueMapPostingSource, and Xapian::FixedWeightPostingSource.

## ◆ unserialise_with_registry()

virtual PostingSource * Xapian::PostingSource::unserialise_with_registry | ( | const std::string & | serialised,
|  | const Registry & | registry
| ) |  | const
| virtual

Create object given string serialisation returned by serialise().

Note that the returned object will be deallocated by Xapian after use with "delete". If you want to handle the deletion in a special way (for example when wrapping the Xapian API for use from another language) then you can define a static `operator delete` method in your subclass as shown here: https://trac.xapian.org/ticket/554#comment:1

This method is supplied with a Registry object, which can be used when unserialising objects contained within the posting source. The default implementation simply calls unserialise() which doesn't take the Registry object, so you do not need to implement this method unless you want to take advantage of the Registry object when unserialising.

Parameters

  serialised | A serialised instance of this PostingSource subclass.
  registry | The Xapian::Registry object to use.

Reimplemented in Xapian::LatLongDistancePostingSource.

The documentation for this class was generated from the following file:

- xapian/postingsource.h